<?php

/**
 * Copyright 2024-2025 Simply.IN Sp. z o.o.
 *
 * NOTICE OF LICENSE
 *
 * Licensed under the EUPL-1.2 or later.
 * You may not use this work except in compliance with the Licence.
 *
 * Copy of the Licence is available at:
 * https://joinup.ec.europa.eu/software/page/eupl
 * It is bundled with this package in the file LICENSE.txt
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the Licence is distributed on an as is basis,
 * without warranties or conditions of any kind, either express or implied.
 * Check the Licence for the specific language governing permissions
 * and limitations under the License.
 *
 * @author   Simply.IN Sp. z o.o.
 * @copyright 2024-2025 Simply.IN Sp. z o.o.
 * @license   https://joinup.ec.europa.eu/software/page/eupl
 */

declare(strict_types=1);

namespace SimplyIn\Payment;

use Order;
use OrderHistory;
use SimplyInPayments;

if (!defined('_PS_VERSION_')) {
    exit;
}

final class OrderStateUpdater implements OrderStateUpdaterInterface
{
    public function update(Order $order, int $newState, string $callback): void
    {
        if ((int) $order->current_state !== $newState) {
            $history = new OrderHistory();
            $history->id_order = (int) $order->id;
            $history->id_employee = 0;
            $history->changeIdOrderState($newState, (int) $order->id);
            $history->add();
        }

        if (method_exists('SimplyInPayments', $callback)) {
            SimplyInPayments::$callback($order->id_cart);
        }
    }
}
